Index: trunk/Config.kmk
===================================================================
--- trunk/Config.kmk	(revision 101213)
+++ trunk/Config.kmk	(revision 101214)
@@ -540,7 +540,4 @@
 if1of ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH), darwin.arm64)
  VBOX_WITH_VIRT_ARMV8 = 1
- # Enables setting hardcoded defaults for newly created VMs,
- # to get the VM off the ground. That setting might go away again as development progresses.
- VBOX_WITH_ARMV8_HARDCODED_DEFAULTS = 1
 endif
 if1of ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH), linux.amd64)
Index: trunk/src/VBox/Main/Makefile.kmk
===================================================================
--- trunk/src/VBox/Main/Makefile.kmk	(revision 101213)
+++ trunk/src/VBox/Main/Makefile.kmk	(revision 101214)
@@ -571,6 +571,5 @@
  	$(if $(VBOX_WITH_FULL_VM_ENCRYPTION),VBOX_WITH_FULL_VM_ENCRYPTION,) \
  	$(if-expr defined(VBOX_WITH_SDS),VBOX_WITH_SDS,) \
- 	$(if $(VBOX_WITH_VIRT_ARMV8),VBOX_WITH_VIRT_ARMV8,) \
- 	$(if $(VBOX_WITH_ARMV8_HARDCODED_DEFAULTS),VBOX_WITH_ARMV8_HARDCODED_DEFAULTS,)
+ 	$(if $(VBOX_WITH_VIRT_ARMV8),VBOX_WITH_VIRT_ARMV8,)
  ifdef VBOX_WITH_USB
   VBoxSVC_DEFS += \
Index: trunk/src/VBox/Main/src-server/GuestOSTypeImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/GuestOSTypeImpl.cpp	(revision 101213)
+++ trunk/src/VBox/Main/src-server/GuestOSTypeImpl.cpp	(revision 101214)
@@ -54,17 +54,4 @@
     , mAudioCodecType(AudioCodecType_STAC9700)
 {
-#ifdef VBOX_WITH_ARMV8_HARDCODED_DEFAULTS
-    unconst(mGraphicsControllerType)    = GraphicsControllerType_VMSVGA;
-    unconst(mVRAMSize)                  = 128; /* MB */
-# ifdef VBOX_WITH_E1000
-    unconst(mNetworkAdapterType)        = NetworkAdapterType_I82540EM;
-# endif
-    unconst(mNumSerialEnabled)          = 1;
-    unconst(mDVDStorageControllerType)  = StorageControllerType_VirtioSCSI;
-    unconst(mDVDStorageBusType)         = StorageBus_VirtioSCSI;
-    unconst(mHDStorageControllerType)   = StorageControllerType_VirtioSCSI;
-    unconst(mHDStorageBusType)          = StorageBus_VirtioSCSI;
-    unconst(mChipsetType)               = ChipsetType_ARMv8Virtual;
-#endif /* VBOX_WITH_ARMV8_HARDCODED_DEFAULTS */
 }
 
@@ -121,5 +108,4 @@
     unconst(mCPUCount)                  = ostype.recommendedCPUCount;
     unconst(mHDDSize)                   = ostype.recommendedHDD;
-#ifndef VBOX_WITH_ARMV8_HARDCODED_DEFAULTS
     unconst(mGraphicsControllerType)    = ostype.graphicsControllerType;
     unconst(mVRAMSize)                  = ostype.recommendedVRAM;
@@ -131,5 +117,4 @@
     unconst(mHDStorageBusType)          = ostype.hdStorageBusType;
     unconst(mChipsetType)               = ostype.chipsetType;
-#endif
     unconst(mIommuType)                 = ostype.iommuType;
     unconst(mAudioControllerType)       = ostype.audioControllerType;
Index: trunk/src/VBox/Main/src-server/MachineImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 101213)
+++ trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 101214)
@@ -506,30 +506,4 @@
         hrc = mNvramStore->i_updateEncryptionSettings(strNVRAMKeyId, strNVRAMKeyStore);
 #endif
-
-#ifdef VBOX_WITH_ARMV8_HARDCODED_DEFAULTS
-        /* At least one serial port has to be enabled. */
-        char szPathTemp[RTPATH_MAX];
-        int vrc = RTPathTemp(szPathTemp, sizeof(szPathTemp)); /* Don't clutter the VM directory; instead use the temp dir. */
-        if (RT_SUCCESS(vrc))
-        {
-            vrc = RTPathAppend(szPathTemp, sizeof(szPathTemp), strName.c_str());
-            if (RT_SUCCESS(vrc))
-            {
-                vrc = RTStrCat(szPathTemp, sizeof(szPathTemp), "-serialPort0");
-                if (RT_SUCCESS(vrc))
-                {
-                    mSerialPorts[0]->COMSETTER(Path)(Bstr(szPathTemp).raw()); /* Must be set first. */
-                    mSerialPorts[0]->COMSETTER(HostMode)(PortMode_RawFile);
-                    mSerialPorts[0]->COMSETTER(Enabled)(TRUE);
-                }
-            }
-        }
-        /* Always needs EFI. */
-        mFirmwareSettings->COMSETTER(FirmwareType)(FirmwareType_EFI);
-        /* Needs VMSVGA for now. */
-        mGraphicsAdapter->COMSETTER(GraphicsControllerType)(GraphicsControllerType_VMSVGA);
-        mGraphicsAdapter->COMSETTER(VRAMSize)(128 /* MB */);
-#endif /* VBOX_WITH_ARMV8_HARDCODED_DEFAULTS */
-
         if (SUCCEEDED(hrc))
         {
@@ -15267,11 +15241,7 @@
         mNetworkAdapters[slot]->i_applyDefaults(osType);
 
-#ifdef VBOX_WITH_ARMV8_HARDCODED_DEFAULTS
-    /* Configuration is done in Machine::init(). */
-#else
     /* Apply serial port defaults */
     for (ULONG slot = 0; slot < RT_ELEMENTS(mSerialPorts); ++slot)
         mSerialPorts[slot]->i_applyDefaults(osType);
-#endif
 
     /* Apply parallel port defaults  - not OS dependent*/
@@ -15366,6 +15336,5 @@
         storageController->COMSETTER(PortCount)(1);
 
-#ifdef VBOX_WITH_ARMV8_HARDCODED_DEFAULTS
-    /* ARM VMs only support VirtioSCSI for now -- set two ports here, one for HDD and one for DVD drive. */
+    /* VirtioSCSI configures only one port per default  -- set two ports here, one for HDD and one for DVD drive. */
     if (hdStorageControllerType == StorageControllerType_VirtioSCSI)
     {
@@ -15373,5 +15342,4 @@
         if (FAILED(hrc)) return hrc;
     }
-#endif
 
     /* USB stuff */